
//****************************************************************************
//        
//
//  : 1.0.1
//  :  2012
//****************************************************************************


#ifndef LoaderDllH
#define LoaderDllH
//----------------------------------------------------------------------------

#include <windows.h>


typedef void* HMEMORYMODULE;

//-------------------------------------------------------
//  MemoryLoadLibrary -     
//                        
//-------------------------------------------------------
HMEMORYMODULE MemoryLoadLibrary( const void* Memory, bool CallDllEntry = true, void* param = 0 );


//-------------------------------------------------------
//  MemoryGetProcAddress -   
//                         DLL
//-------------------------------------------------------
FARPROC MemoryGetProcAddress(HMEMORYMODULE Dll, const char* Name);
FARPROC MemoryGetProcAddress(HMEMORYMODULE Dll, DWORD NameHash);

//-------------------------------------------------------
//  MemoryFreeLibrary -   
//                        DLL  
//-------------------------------------------------------
void MemoryFreeLibrary(HMEMORYMODULE);




//*******************************************************
//       DLL
//*******************************************************

//----------------------------------
//   DLL
//----------------------------------
#define ENCRYPTED_DLL_MARKER   "_DLL_DATA_"


//----------------------------------
//    DLL
//----------------------------------
#define ENCRYPTED_DLL_MARKER_SIZE 10

//----------------------------------
//    DLL
//----------------------------------
#define ENCRYPTED_DLL_MARKER_HASH 0x8CAC120C /* _DLL_DATA_ */




//---------------------------------------------------------
//    
//
//  DllBuf -     
//
//   :
//
//  DllSize -   
//  NewBuf  -    
//  NewBufAllocated -   , 
//                        
//---------------------------------------------------------
bool DecodeDll(const void* DllBuf, DWORD &DllSize, LPVOID &NewBuf, bool &NewBufAllocated);


HMEMORYMODULE MemoryLoadEncryptedLibrary( const void*);

//----------------------------------------------------------------------------
#endif