#include <windows.h>


#ifndef MemoryH
#define MemoryH
//-----------------------------------------------------------------------------

void *m_memset(void *szBuffer, DWORD dwSym, DWORD dwLen);
void *m_memcpy(void *szBuf, const void *szStr, int nLen);
int   m_memcmp(const void *buf1, const void *buf2, size_t count);


/*---------------------------------------------------------------------------*/
//       VirtualAlloc
//      ,    ,
//         
// ,    .
//
//        
//    .    MemHeap...
/*---------------------------------------------------------------------------*/

//    
DWORD  GetMemSize(LPVOID lpAddr);

//  
VOID   MemFree(LPVOID lpAddr);

//    
LPVOID MemAlloc(DWORD dwSize);

//      
LPVOID MemAllocAndClear(DWORD Size);

//  
LPVOID MemRealloc(LPVOID lpAddr, DWORD dwSize );


/*---------------------------------------------------------------------------*/
//         
//       WINAPI   
//    .
//   ,      
//    
/*---------------------------------------------------------------------------*/

namespace HEAP
{
	LPVOID Alloc(DWORD Size);

	LPVOID ReAlloc(LPVOID Buf, DWORD Size);
	bool ReAlloc2(LPVOID &Buf, DWORD Size);

	void Free(LPVOID Buf);
	void Free2(LPVOID &Buf);

	DWORD Size(LPVOID Buf);
}

/*---------------------------------------------------------------------------*/
//     
/*---------------------------------------------------------------------------*/

//   
#define ClearStruct(S) m_memset(&S, 0, sizeof(S))

//        
#define CreateStruct(T) (T*)HEAP::Alloc(sizeof(T))

//        
#define FreeStruct(S) HEAP::Free(S);

//-----------------------------------------------------------------------------
#endif

